diff --git a/modules/lang-painless/src/main/java/org/elasticsearch/painless/action/PainlessExecuteAction.java b/modules/lang-painless/src/main/java/org/elasticsearch/painless/action/PainlessExecuteAction.java
index 217b5fc76588a..cb407978da83e 100644
--- a/modules/lang-painless/src/main/java/org/elasticsearch/painless/action/PainlessExecuteAction.java
+++ b/modules/lang-painless/src/main/java/org/elasticsearch/painless/action/PainlessExecuteAction.java
@@ -101,7 +101,7 @@ private PainlessExecuteAction() {
 
     @Override
     public Response newResponse() {
-        return new Response();
+        throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
     }
 
     public static class Request extends SingleShardRequest<Request> implements ToXContentObject {
@@ -381,20 +381,22 @@ static boolean needDocumentAndIndex(ScriptContext<?> scriptContext) {
 
         private Object result;
 
-        Response() {}
-
         Response(Object result) {
             this.result = result;
         }
 
+        Response(StreamInput in) throws IOException {
+            super(in);
+            result = in.readGenericValue();
+        }
+
         public Object getResult() {
             return result;
         }
 
         @Override
         public void readFrom(StreamInput in) throws IOException {
-            super.readFrom(in);
-            result = in.readGenericValue();
+            throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
         }
 
         @Override
@@ -469,8 +471,8 @@ public TransportAction(ThreadPool threadPool, TransportService transportService,
         }
 
         @Override
-        protected Response newResponse() {
-            return new Response();
+        protected Writeable.Reader<Response> getResponseReader() {
+            return Response::new;
         }
 
         @Override
diff --git a/modules/lang-painless/src/test/java/org/elasticsearch/painless/action/PainlessExecuteResponseTests.java b/modules/lang-painless/src/test/java/org/elasticsearch/painless/action/PainlessExecuteResponseTests.java
index c75497bd630e5..ed75caff76b50 100644
--- a/modules/lang-painless/src/test/java/org/elasticsearch/painless/action/PainlessExecuteResponseTests.java
+++ b/modules/lang-painless/src/test/java/org/elasticsearch/painless/action/PainlessExecuteResponseTests.java
@@ -18,17 +18,57 @@
  */
 package org.elasticsearch.painless.action;
 
-import org.elasticsearch.test.AbstractStreamableTestCase;
+import org.elasticsearch.common.io.stream.Writeable;
+import org.elasticsearch.common.xcontent.XContentParser;
+import org.elasticsearch.test.AbstractSerializingTestCase;
 
-public class PainlessExecuteResponseTests extends AbstractStreamableTestCase<PainlessExecuteAction.Response> {
+import java.io.IOException;
+
+public class PainlessExecuteResponseTests extends AbstractSerializingTestCase<PainlessExecuteAction.Response> {
 
     @Override
-    protected PainlessExecuteAction.Response createBlankInstance() {
-        return new PainlessExecuteAction.Response();
+    protected Writeable.Reader<PainlessExecuteAction.Response> instanceReader() {
+        return PainlessExecuteAction.Response::new;
     }
 
     @Override
     protected PainlessExecuteAction.Response createTestInstance() {
-        return new PainlessExecuteAction.Response(randomAlphaOfLength(10));
+        Object result;
+        switch (randomIntBetween(0, 2)) {
+            case 0:
+                result = randomAlphaOfLength(10);
+                break;
+            case 1:
+                result = randomBoolean();
+                break;
+            case 2:
+                result = randomDoubleBetween(-10, 10, true);
+                break;
+            default:
+                throw new IllegalStateException("invalid branch");
+        }
+        return new PainlessExecuteAction.Response(result);
+    }
+
+    @Override
+    protected PainlessExecuteAction.Response doParseInstance(XContentParser parser) throws IOException {
+        parser.nextToken(); // START-OBJECT
+        parser.nextToken(); // FIELD-NAME
+        XContentParser.Token token = parser.nextToken(); // result value
+        Object result;
+        switch (token) {
+            case VALUE_STRING:
+                result = parser.text();
+                break;
+            case VALUE_BOOLEAN:
+                result = parser.booleanValue();
+                break;
+            case VALUE_NUMBER:
+                result = parser.doubleValue();
+                break;
+            default:
+                throw new IOException("invalid response");
+        }
+        return new PainlessExecuteAction.Response(result);
     }
 }
diff --git a/server/src/main/java/org/elasticsearch/action/admin/indices/analyze/AnalyzeResponse.java b/server/src/main/java/org/elasticsearch/action/admin/indices/analyze/AnalyzeResponse.java
index 945c2128bab39..7e6d525cefb93 100644
--- a/server/src/main/java/org/elasticsearch/action/admin/indices/analyze/AnalyzeResponse.java
+++ b/server/src/main/java/org/elasticsearch/action/admin/indices/analyze/AnalyzeResponse.java
@@ -71,7 +71,7 @@ public int hashCode() {
             return Objects.hash(term, startOffset, endOffset, position, positionLength, attributes, type);
         }
 
-        public AnalyzeToken(String term, int position, int startOffset, int endOffset, int positionLength,
+        AnalyzeToken(String term, int position, int startOffset, int endOffset, int positionLength,
                             String type, Map<String, Object> attributes) {
             this.term = term;
             this.position = position;
@@ -82,7 +82,7 @@ public AnalyzeToken(String term, int position, int startOffset, int endOffset, i
             this.attributes = attributes;
         }
 
-        public AnalyzeToken(StreamInput in) throws IOException {
+        AnalyzeToken(StreamInput in) throws IOException {
             term = in.readString();
             startOffset = in.readInt();
             endOffset = in.readInt();
@@ -203,7 +203,6 @@ public void writeTo(StreamOutput out) throws IOException {
     }
 
     private final DetailAnalyzeResponse detail;
-
     private final List<AnalyzeToken> tokens;
 
     public AnalyzeResponse(List<AnalyzeToken> tokens, DetailAnalyzeResponse detail) {
diff --git a/server/src/main/java/org/elasticsearch/action/admin/indices/analyze/TransportAnalyzeAction.java b/server/src/main/java/org/elasticsearch/action/admin/indices/analyze/TransportAnalyzeAction.java
index 07f445b6fc74a..62d8c0e91da79 100644
--- a/server/src/main/java/org/elasticsearch/action/admin/indices/analyze/TransportAnalyzeAction.java
+++ b/server/src/main/java/org/elasticsearch/action/admin/indices/analyze/TransportAnalyzeAction.java
@@ -96,11 +96,6 @@ public TransportAnalyzeAction(Settings settings, ThreadPool threadPool, ClusterS
         this.environment = environment;
     }
 
-    @Override
-    protected AnalyzeResponse newResponse() {
-        throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
-    }
-
     @Override
     protected Writeable.Reader<AnalyzeResponse> getResponseReader() {
         return AnalyzeResponse::new;
diff --git a/server/src/main/java/org/elasticsearch/action/admin/indices/mapping/get/GetFieldMappingsAction.java b/server/src/main/java/org/elasticsearch/action/admin/indices/mapping/get/GetFieldMappingsAction.java
index 5aa19652b676d..d372d8cf93f30 100644
--- a/server/src/main/java/org/elasticsearch/action/admin/indices/mapping/get/GetFieldMappingsAction.java
+++ b/server/src/main/java/org/elasticsearch/action/admin/indices/mapping/get/GetFieldMappingsAction.java
@@ -20,6 +20,7 @@
 package org.elasticsearch.action.admin.indices.mapping.get;
 
 import org.elasticsearch.action.Action;
+import org.elasticsearch.common.io.stream.Writeable;
 
 public class GetFieldMappingsAction extends Action<GetFieldMappingsResponse> {
 
@@ -32,6 +33,11 @@ private GetFieldMappingsAction() {
 
     @Override
     public GetFieldMappingsResponse newResponse() {
-        return new GetFieldMappingsResponse();
+        throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
+    }
+
+    @Override
+    public Writeable.Reader<GetFieldMappingsResponse> getResponseReader() {
+        return GetFieldMappingsResponse::new;
     }
 }
diff --git a/server/src/main/java/org/elasticsearch/action/admin/indices/mapping/get/GetFieldMappingsResponse.java b/server/src/main/java/org/elasticsearch/action/admin/indices/mapping/get/GetFieldMappingsResponse.java
index d3200bc1e1d9a..e3be9e6834287 100644
--- a/server/src/main/java/org/elasticsearch/action/admin/indices/mapping/get/GetFieldMappingsResponse.java
+++ b/server/src/main/java/org/elasticsearch/action/admin/indices/mapping/get/GetFieldMappingsResponse.java
@@ -92,9 +92,33 @@
         this.mappings = mappings;
     }
 
+
     GetFieldMappingsResponse() {
     }
 
+    GetFieldMappingsResponse(StreamInput in) throws IOException {
+        super(in);
+        int size = in.readVInt();
+        Map<String, Map<String, Map<String, FieldMappingMetaData>>> indexMapBuilder = new HashMap<>(size);
+        for (int i = 0; i < size; i++) {
+            String index = in.readString();
+            int typesSize = in.readVInt();
+            Map<String, Map<String, FieldMappingMetaData>> typeMapBuilder = new HashMap<>(typesSize);
+            for (int j = 0; j < typesSize; j++) {
+                String type = in.readString();
+                int fieldSize = in.readVInt();
+                Map<String, FieldMappingMetaData> fieldMapBuilder = new HashMap<>(fieldSize);
+                for (int k = 0; k < fieldSize; k++) {
+                    fieldMapBuilder.put(in.readString(), new FieldMappingMetaData(in.readString(), in.readBytesReference()));
+                }
+                typeMapBuilder.put(type, unmodifiableMap(fieldMapBuilder));
+            }
+            indexMapBuilder.put(index, unmodifiableMap(typeMapBuilder));
+        }
+        mappings = unmodifiableMap(indexMapBuilder);
+
+    }
+
     /** returns the retrieved field mapping. The return map keys are index, type, field (as specified in the request). */
     public Map<String, Map<String, Map<String, FieldMappingMetaData>>> mappings() {
         return mappings;
@@ -269,25 +293,7 @@ public int hashCode() {
 
     @Override
     public void readFrom(StreamInput in) throws IOException {
-        super.readFrom(in);
-        int size = in.readVInt();
-        Map<String, Map<String, Map<String, FieldMappingMetaData>>> indexMapBuilder = new HashMap<>(size);
-        for (int i = 0; i < size; i++) {
-            String index = in.readString();
-            int typesSize = in.readVInt();
-            Map<String, Map<String, FieldMappingMetaData>> typeMapBuilder = new HashMap<>(typesSize);
-            for (int j = 0; j < typesSize; j++) {
-                String type = in.readString();
-                int fieldSize = in.readVInt();
-                Map<String, FieldMappingMetaData> fieldMapBuilder = new HashMap<>(fieldSize);
-                for (int k = 0; k < fieldSize; k++) {
-                    fieldMapBuilder.put(in.readString(), new FieldMappingMetaData(in.readString(), in.readBytesReference()));
-                }
-                typeMapBuilder.put(type, unmodifiableMap(fieldMapBuilder));
-            }
-            indexMapBuilder.put(index, unmodifiableMap(typeMapBuilder));
-        }
-        mappings = unmodifiableMap(indexMapBuilder);
+        throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
     }
 
     @Override
diff --git a/server/src/main/java/org/elasticsearch/action/admin/indices/mapping/get/TransportGetFieldMappingsIndexAction.java b/server/src/main/java/org/elasticsearch/action/admin/indices/mapping/get/TransportGetFieldMappingsIndexAction.java
index c7415391675fc..61a598c361cc9 100644
--- a/server/src/main/java/org/elasticsearch/action/admin/indices/mapping/get/TransportGetFieldMappingsIndexAction.java
+++ b/server/src/main/java/org/elasticsearch/action/admin/indices/mapping/get/TransportGetFieldMappingsIndexAction.java
@@ -32,6 +32,7 @@
 import org.elasticsearch.cluster.service.ClusterService;
 import org.elasticsearch.common.bytes.BytesReference;
 import org.elasticsearch.common.inject.Inject;
+import org.elasticsearch.common.io.stream.Writeable;
 import org.elasticsearch.common.regex.Regex;
 import org.elasticsearch.common.xcontent.ToXContent;
 import org.elasticsearch.common.xcontent.XContentHelper;
@@ -123,8 +124,8 @@ protected GetFieldMappingsResponse shardOperation(final GetFieldMappingsIndexReq
     }
 
     @Override
-    protected GetFieldMappingsResponse newResponse() {
-        return new GetFieldMappingsResponse();
+    protected Writeable.Reader<GetFieldMappingsResponse> getResponseReader() {
+        return GetFieldMappingsResponse::new;
     }
 
     @Override
diff --git a/server/src/main/java/org/elasticsearch/action/explain/ExplainAction.java b/server/src/main/java/org/elasticsearch/action/explain/ExplainAction.java
index 13c9d94e7dbc7..ba5618ce7de21 100644
--- a/server/src/main/java/org/elasticsearch/action/explain/ExplainAction.java
+++ b/server/src/main/java/org/elasticsearch/action/explain/ExplainAction.java
@@ -20,6 +20,7 @@
 package org.elasticsearch.action.explain;
 
 import org.elasticsearch.action.Action;
+import org.elasticsearch.common.io.stream.Writeable;
 
 /**
  * Entry point for the explain feature.
@@ -35,6 +36,11 @@ private ExplainAction() {
 
     @Override
     public ExplainResponse newResponse() {
-        return new ExplainResponse();
+        throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
+    }
+
+    @Override
+    public Writeable.Reader<ExplainResponse> getResponseReader() {
+        return ExplainResponse::new;
     }
 }
diff --git a/server/src/main/java/org/elasticsearch/action/explain/ExplainResponse.java b/server/src/main/java/org/elasticsearch/action/explain/ExplainResponse.java
index 5cecdf3a8b6b3..8ea7d0f12e341 100644
--- a/server/src/main/java/org/elasticsearch/action/explain/ExplainResponse.java
+++ b/server/src/main/java/org/elasticsearch/action/explain/ExplainResponse.java
@@ -60,6 +60,7 @@
     private Explanation explanation;
     private GetResult getResult;
 
+    // TODO(talevy): remove dependency on empty constructor from ExplainResponseTests
     ExplainResponse() {
     }
 
@@ -80,6 +81,20 @@ public ExplainResponse(String index, String type, String id, boolean exists, Exp
         this.getResult = getResult;
     }
 
+    public ExplainResponse(StreamInput in) throws IOException {
+        super(in);
+        index = in.readString();
+        type = in.readString();
+        id = in.readString();
+        exists = in.readBoolean();
+        if (in.readBoolean()) {
+            explanation = readExplanation(in);
+        }
+        if (in.readBoolean()) {
+            getResult = GetResult.readGetResult(in);
+        }
+    }
+
     public String getIndex() {
         return index;
     }
@@ -123,17 +138,7 @@ public RestStatus status() {
 
     @Override
     public void readFrom(StreamInput in) throws IOException {
-        super.readFrom(in);
-        index = in.readString();
-        type = in.readString();
-        id = in.readString();
-        exists = in.readBoolean();
-        if (in.readBoolean()) {
-            explanation = readExplanation(in);
-        }
-        if (in.readBoolean()) {
-            getResult = GetResult.readGetResult(in);
-        }
+        throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
     }
 
     @Override
diff --git a/server/src/main/java/org/elasticsearch/action/explain/TransportExplainAction.java b/server/src/main/java/org/elasticsearch/action/explain/TransportExplainAction.java
index fe8475322592f..c29da21fe4afe 100644
--- a/server/src/main/java/org/elasticsearch/action/explain/TransportExplainAction.java
+++ b/server/src/main/java/org/elasticsearch/action/explain/TransportExplainAction.java
@@ -32,6 +32,7 @@
 import org.elasticsearch.cluster.service.ClusterService;
 import org.elasticsearch.common.Strings;
 import org.elasticsearch.common.inject.Inject;
+import org.elasticsearch.common.io.stream.Writeable;
 import org.elasticsearch.common.lease.Releasables;
 import org.elasticsearch.index.IndexService;
 import org.elasticsearch.index.engine.Engine;
@@ -152,8 +153,8 @@ protected ExplainResponse shardOperation(ExplainRequest request, ShardId shardId
     }
 
     @Override
-    protected ExplainResponse newResponse() {
-        return new ExplainResponse();
+    protected Writeable.Reader<ExplainResponse> getResponseReader() {
+        return ExplainResponse::new;
     }
 
     @Override
diff --git a/server/src/main/java/org/elasticsearch/action/fieldcaps/TransportFieldCapabilitiesIndexAction.java b/server/src/main/java/org/elasticsearch/action/fieldcaps/TransportFieldCapabilitiesIndexAction.java
index 01c21544047ed..274633b12a613 100644
--- a/server/src/main/java/org/elasticsearch/action/fieldcaps/TransportFieldCapabilitiesIndexAction.java
+++ b/server/src/main/java/org/elasticsearch/action/fieldcaps/TransportFieldCapabilitiesIndexAction.java
@@ -28,6 +28,7 @@
 import org.elasticsearch.cluster.routing.ShardsIterator;
 import org.elasticsearch.cluster.service.ClusterService;
 import org.elasticsearch.common.inject.Inject;
+import org.elasticsearch.common.io.stream.Writeable;
 import org.elasticsearch.index.mapper.MappedFieldType;
 import org.elasticsearch.index.mapper.MapperService;
 import org.elasticsearch.index.mapper.ObjectMapper;
@@ -114,8 +115,8 @@ protected FieldCapabilitiesIndexResponse shardOperation(final FieldCapabilitiesI
     }
 
     @Override
-    protected FieldCapabilitiesIndexResponse newResponse() {
-        return new FieldCapabilitiesIndexResponse();
+    protected Writeable.Reader<FieldCapabilitiesIndexResponse> getResponseReader() {
+        return FieldCapabilitiesIndexResponse::new;
     }
 
     @Override
diff --git a/server/src/main/java/org/elasticsearch/action/get/GetAction.java b/server/src/main/java/org/elasticsearch/action/get/GetAction.java
index a622fd5a8178b..05d1b6c5a4c02 100644
--- a/server/src/main/java/org/elasticsearch/action/get/GetAction.java
+++ b/server/src/main/java/org/elasticsearch/action/get/GetAction.java
@@ -20,6 +20,7 @@
 package org.elasticsearch.action.get;
 
 import org.elasticsearch.action.Action;
+import org.elasticsearch.common.io.stream.Writeable;
 
 public class GetAction extends Action<GetResponse> {
 
@@ -32,6 +33,11 @@ private GetAction() {
 
     @Override
     public GetResponse newResponse() {
-        return new GetResponse();
+        throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
+    }
+
+    @Override
+    public Writeable.Reader<GetResponse> getResponseReader() {
+        return GetResponse::new;
     }
 }
diff --git a/server/src/main/java/org/elasticsearch/action/get/GetResponse.java b/server/src/main/java/org/elasticsearch/action/get/GetResponse.java
index b9383785678b7..3d340d455ceb8 100644
--- a/server/src/main/java/org/elasticsearch/action/get/GetResponse.java
+++ b/server/src/main/java/org/elasticsearch/action/get/GetResponse.java
@@ -48,7 +48,9 @@
 
     GetResult getResult;
 
-    GetResponse() {
+    GetResponse(StreamInput in) throws IOException {
+        super(in);
+        getResult = GetResult.readGetResult(in);
     }
 
     public GetResponse(GetResult getResult) {
@@ -203,8 +205,7 @@ public static GetResponse fromXContent(XContentParser parser) throws IOException
 
     @Override
     public void readFrom(StreamInput in) throws IOException {
-        super.readFrom(in);
-        getResult = GetResult.readGetResult(in);
+        throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
     }
 
     @Override
diff --git a/server/src/main/java/org/elasticsearch/action/get/MultiGetItemResponse.java b/server/src/main/java/org/elasticsearch/action/get/MultiGetItemResponse.java
index 97ff2fe769f68..e104359a65e7c 100644
--- a/server/src/main/java/org/elasticsearch/action/get/MultiGetItemResponse.java
+++ b/server/src/main/java/org/elasticsearch/action/get/MultiGetItemResponse.java
@@ -104,8 +104,7 @@ public void readFrom(StreamInput in) throws IOException {
         if (in.readBoolean()) {
             failure = MultiGetResponse.Failure.readFailure(in);
         } else {
-            response = new GetResponse();
-            response.readFrom(in);
+            response = new GetResponse(in);
         }
     }
 
@@ -119,4 +118,4 @@ public void writeTo(StreamOutput out) throws IOException {
             response.writeTo(out);
         }
     }
-}
\ No newline at end of file
+}
diff --git a/server/src/main/java/org/elasticsearch/action/get/MultiGetShardResponse.java b/server/src/main/java/org/elasticsearch/action/get/MultiGetShardResponse.java
index 0d15f45dcb2a4..477471e2aabd7 100644
--- a/server/src/main/java/org/elasticsearch/action/get/MultiGetShardResponse.java
+++ b/server/src/main/java/org/elasticsearch/action/get/MultiGetShardResponse.java
@@ -30,9 +30,9 @@
 
 public class MultiGetShardResponse extends ActionResponse {
 
-    IntArrayList locations;
-    List<GetResponse> responses;
-    List<MultiGetResponse.Failure> failures;
+    final IntArrayList locations;
+    final List<GetResponse> responses;
+    final List<MultiGetResponse.Failure> failures;
 
     MultiGetShardResponse() {
         locations = new IntArrayList();
@@ -40,21 +40,8 @@
         failures = new ArrayList<>();
     }
 
-    public void add(int location, GetResponse response) {
-        locations.add(location);
-        responses.add(response);
-        failures.add(null);
-    }
-
-    public void add(int location, MultiGetResponse.Failure failure) {
-        locations.add(location);
-        responses.add(null);
-        failures.add(failure);
-    }
-
-    @Override
-    public void readFrom(StreamInput in) throws IOException {
-        super.readFrom(in);
+    MultiGetShardResponse(StreamInput in) throws IOException {
+        super(in);
         int size = in.readVInt();
         locations = new IntArrayList(size);
         responses = new ArrayList<>(size);
@@ -62,9 +49,7 @@ public void readFrom(StreamInput in) throws IOException {
         for (int i = 0; i < size; i++) {
             locations.add(in.readVInt());
             if (in.readBoolean()) {
-                GetResponse response = new GetResponse();
-                response.readFrom(in);
-                responses.add(response);
+                responses.add(new GetResponse(in));
             } else {
                 responses.add(null);
             }
@@ -76,6 +61,23 @@ public void readFrom(StreamInput in) throws IOException {
         }
     }
 
+    public void add(int location, GetResponse response) {
+        locations.add(location);
+        responses.add(response);
+        failures.add(null);
+    }
+
+    public void add(int location, MultiGetResponse.Failure failure) {
+        locations.add(location);
+        responses.add(null);
+        failures.add(failure);
+    }
+
+    @Override
+    public void readFrom(StreamInput in) throws IOException {
+        throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
+    }
+
     @Override
     public void writeTo(StreamOutput out) throws IOException {
         super.writeTo(out);
@@ -96,4 +98,4 @@ public void writeTo(StreamOutput out) throws IOException {
             }
         }
     }
-}
\ No newline at end of file
+}
diff --git a/server/src/main/java/org/elasticsearch/action/get/TransportGetAction.java b/server/src/main/java/org/elasticsearch/action/get/TransportGetAction.java
index 7bc736b69f38c..65f42835f7374 100644
--- a/server/src/main/java/org/elasticsearch/action/get/TransportGetAction.java
+++ b/server/src/main/java/org/elasticsearch/action/get/TransportGetAction.java
@@ -28,6 +28,7 @@
 import org.elasticsearch.cluster.routing.ShardIterator;
 import org.elasticsearch.cluster.service.ClusterService;
 import org.elasticsearch.common.inject.Inject;
+import org.elasticsearch.common.io.stream.Writeable;
 import org.elasticsearch.index.IndexService;
 import org.elasticsearch.index.get.GetResult;
 import org.elasticsearch.index.shard.IndexShard;
@@ -108,8 +109,8 @@ protected GetResponse shardOperation(GetRequest request, ShardId shardId) {
     }
 
     @Override
-    protected GetResponse newResponse() {
-        return new GetResponse();
+    protected Writeable.Reader<GetResponse> getResponseReader() {
+        return GetResponse::new;
     }
 
     @Override
diff --git a/server/src/main/java/org/elasticsearch/action/get/TransportShardMultiGetAction.java b/server/src/main/java/org/elasticsearch/action/get/TransportShardMultiGetAction.java
index 6c48b3b87c59f..9b8ea6bd6cac5 100644
--- a/server/src/main/java/org/elasticsearch/action/get/TransportShardMultiGetAction.java
+++ b/server/src/main/java/org/elasticsearch/action/get/TransportShardMultiGetAction.java
@@ -28,6 +28,7 @@
 import org.elasticsearch.cluster.routing.ShardIterator;
 import org.elasticsearch.cluster.service.ClusterService;
 import org.elasticsearch.common.inject.Inject;
+import org.elasticsearch.common.io.stream.Writeable;
 import org.elasticsearch.index.IndexService;
 import org.elasticsearch.index.get.GetResult;
 import org.elasticsearch.index.shard.IndexShard;
@@ -57,8 +58,8 @@ protected boolean isSubAction() {
     }
 
     @Override
-    protected MultiGetShardResponse newResponse() {
-        return new MultiGetShardResponse();
+    protected Writeable.Reader<MultiGetShardResponse> getResponseReader() {
+        return MultiGetShardResponse::new;
     }
 
     @Override
diff --git a/server/src/main/java/org/elasticsearch/action/support/single/shard/TransportSingleShardAction.java b/server/src/main/java/org/elasticsearch/action/support/single/shard/TransportSingleShardAction.java
index 8b0e69bd457c8..3c2e7f9a49e0d 100644
--- a/server/src/main/java/org/elasticsearch/action/support/single/shard/TransportSingleShardAction.java
+++ b/server/src/main/java/org/elasticsearch/action/support/single/shard/TransportSingleShardAction.java
@@ -120,16 +120,7 @@ protected void doRun() throws Exception {
         });
     }
 
-    @Deprecated
-    protected abstract Response newResponse();
-
-    protected Writeable.Reader<Response> getResponseReader() {
-        return in -> {
-            Response response = newResponse();
-            response.readFrom(in);
-            return response;
-        };
-    }
+    protected abstract Writeable.Reader<Response> getResponseReader();
 
     protected abstract boolean resolveIndex(Request request);
 
diff --git a/server/src/main/java/org/elasticsearch/action/termvectors/MultiTermVectorsItemResponse.java b/server/src/main/java/org/elasticsearch/action/termvectors/MultiTermVectorsItemResponse.java
index 3e32af7f2c250..14ac59cb132bd 100644
--- a/server/src/main/java/org/elasticsearch/action/termvectors/MultiTermVectorsItemResponse.java
+++ b/server/src/main/java/org/elasticsearch/action/termvectors/MultiTermVectorsItemResponse.java
@@ -105,8 +105,7 @@ public void readFrom(StreamInput in) throws IOException {
         if (in.readBoolean()) {
             failure = MultiTermVectorsResponse.Failure.readFailure(in);
         } else {
-            response = new TermVectorsResponse();
-            response.readFrom(in);
+            response = new TermVectorsResponse(in);
         }
     }
 
@@ -120,4 +119,4 @@ public void writeTo(StreamOutput out) throws IOException {
             response.writeTo(out);
         }
     }
-}
\ No newline at end of file
+}
diff --git a/server/src/main/java/org/elasticsearch/action/termvectors/MultiTermVectorsShardResponse.java b/server/src/main/java/org/elasticsearch/action/termvectors/MultiTermVectorsShardResponse.java
index 346274c5925b3..2290ee9f52e42 100644
--- a/server/src/main/java/org/elasticsearch/action/termvectors/MultiTermVectorsShardResponse.java
+++ b/server/src/main/java/org/elasticsearch/action/termvectors/MultiTermVectorsShardResponse.java
@@ -30,9 +30,9 @@
 
 public class MultiTermVectorsShardResponse extends ActionResponse {
 
-    IntArrayList locations;
-    List<TermVectorsResponse> responses;
-    List<MultiTermVectorsResponse.Failure> failures;
+    final IntArrayList locations;
+    final List<TermVectorsResponse> responses;
+    final List<MultiTermVectorsResponse.Failure> failures;
 
     MultiTermVectorsShardResponse() {
         locations = new IntArrayList();
@@ -40,21 +40,8 @@
         failures = new ArrayList<>();
     }
 
-    public void add(int location, TermVectorsResponse response) {
-        locations.add(location);
-        responses.add(response);
-        failures.add(null);
-    }
-
-    public void add(int location, MultiTermVectorsResponse.Failure failure) {
-        locations.add(location);
-        responses.add(null);
-        failures.add(failure);
-    }
-
-    @Override
-    public void readFrom(StreamInput in) throws IOException {
-        super.readFrom(in);
+    MultiTermVectorsShardResponse(StreamInput in) throws IOException {
+        super(in);
         int size = in.readVInt();
         locations = new IntArrayList(size);
         responses = new ArrayList<>(size);
@@ -62,9 +49,7 @@ public void readFrom(StreamInput in) throws IOException {
         for (int i = 0; i < size; i++) {
             locations.add(in.readVInt());
             if (in.readBoolean()) {
-                TermVectorsResponse response = new TermVectorsResponse();
-                response.readFrom(in);
-                responses.add(response);
+                responses.add(new TermVectorsResponse(in));
             } else {
                 responses.add(null);
             }
@@ -76,6 +61,23 @@ public void readFrom(StreamInput in) throws IOException {
         }
     }
 
+    public void add(int location, TermVectorsResponse response) {
+        locations.add(location);
+        responses.add(response);
+        failures.add(null);
+    }
+
+    public void add(int location, MultiTermVectorsResponse.Failure failure) {
+        locations.add(location);
+        responses.add(null);
+        failures.add(failure);
+    }
+
+    @Override
+    public void readFrom(StreamInput in) throws IOException {
+        throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
+    }
+
     @Override
     public void writeTo(StreamOutput out) throws IOException {
         super.writeTo(out);
@@ -96,4 +98,4 @@ public void writeTo(StreamOutput out) throws IOException {
             }
         }
     }
-}
\ No newline at end of file
+}
diff --git a/server/src/main/java/org/elasticsearch/action/termvectors/TermVectorsAction.java b/server/src/main/java/org/elasticsearch/action/termvectors/TermVectorsAction.java
index e701efe93ba7a..9b223eed3a3c8 100644
--- a/server/src/main/java/org/elasticsearch/action/termvectors/TermVectorsAction.java
+++ b/server/src/main/java/org/elasticsearch/action/termvectors/TermVectorsAction.java
@@ -20,6 +20,7 @@
 package org.elasticsearch.action.termvectors;
 
 import org.elasticsearch.action.Action;
+import org.elasticsearch.common.io.stream.Writeable;
 
 public class TermVectorsAction extends Action<TermVectorsResponse> {
 
@@ -32,6 +33,11 @@ private TermVectorsAction() {
 
     @Override
     public TermVectorsResponse newResponse() {
-        return new TermVectorsResponse();
+        throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
+    }
+
+    @Override
+    public Writeable.Reader<TermVectorsResponse> getResponseReader() {
+        return TermVectorsResponse::new;
     }
 }
diff --git a/server/src/main/java/org/elasticsearch/action/termvectors/TermVectorsResponse.java b/server/src/main/java/org/elasticsearch/action/termvectors/TermVectorsResponse.java
index 9159a07e83c03..3d0fb75f8d3eb 100644
--- a/server/src/main/java/org/elasticsearch/action/termvectors/TermVectorsResponse.java
+++ b/server/src/main/java/org/elasticsearch/action/termvectors/TermVectorsResponse.java
@@ -103,6 +103,20 @@ public TermVectorsResponse(String index, String type, String id) {
     TermVectorsResponse() {
     }
 
+    TermVectorsResponse(StreamInput in) throws IOException {
+        index = in.readString();
+        type = in.readString();
+        id = in.readString();
+        docVersion = in.readVLong();
+        exists = in.readBoolean();
+        artificial = in.readBoolean();
+        tookInMillis = in.readVLong();
+        if (in.readBoolean()) {
+            headerRef = in.readBytesReference();
+            termVectors = in.readBytesReference();
+        }
+    }
+
     @Override
     public void writeTo(StreamOutput out) throws IOException {
         out.writeString(index);
@@ -127,17 +141,7 @@ private boolean hasTermVectors() {
 
     @Override
     public void readFrom(StreamInput in) throws IOException {
-        index = in.readString();
-        type = in.readString();
-        id = in.readString();
-        docVersion = in.readVLong();
-        exists = in.readBoolean();
-        artificial = in.readBoolean();
-        tookInMillis = in.readVLong();
-        if (in.readBoolean()) {
-            headerRef = in.readBytesReference();
-            termVectors = in.readBytesReference();
-        }
+        throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
     }
 
     public Fields getFields() throws IOException {
diff --git a/server/src/main/java/org/elasticsearch/action/termvectors/TransportShardMultiTermsVectorAction.java b/server/src/main/java/org/elasticsearch/action/termvectors/TransportShardMultiTermsVectorAction.java
index e8d6c1bcb4ff6..0292757121eff 100644
--- a/server/src/main/java/org/elasticsearch/action/termvectors/TransportShardMultiTermsVectorAction.java
+++ b/server/src/main/java/org/elasticsearch/action/termvectors/TransportShardMultiTermsVectorAction.java
@@ -28,6 +28,7 @@
 import org.elasticsearch.cluster.routing.ShardIterator;
 import org.elasticsearch.cluster.service.ClusterService;
 import org.elasticsearch.common.inject.Inject;
+import org.elasticsearch.common.io.stream.Writeable;
 import org.elasticsearch.index.IndexService;
 import org.elasticsearch.index.shard.IndexShard;
 import org.elasticsearch.index.shard.ShardId;
@@ -58,8 +59,8 @@ protected boolean isSubAction() {
     }
 
     @Override
-    protected MultiTermVectorsShardResponse newResponse() {
-        return new MultiTermVectorsShardResponse();
+    protected Writeable.Reader<MultiTermVectorsShardResponse> getResponseReader() {
+        return MultiTermVectorsShardResponse::new;
     }
 
     @Override
diff --git a/server/src/main/java/org/elasticsearch/action/termvectors/TransportTermVectorsAction.java b/server/src/main/java/org/elasticsearch/action/termvectors/TransportTermVectorsAction.java
index d87a08a0541aa..0e212ab7cce2f 100644
--- a/server/src/main/java/org/elasticsearch/action/termvectors/TransportTermVectorsAction.java
+++ b/server/src/main/java/org/elasticsearch/action/termvectors/TransportTermVectorsAction.java
@@ -29,6 +29,7 @@
 import org.elasticsearch.cluster.routing.ShardIterator;
 import org.elasticsearch.cluster.service.ClusterService;
 import org.elasticsearch.common.inject.Inject;
+import org.elasticsearch.common.io.stream.Writeable;
 import org.elasticsearch.index.IndexService;
 import org.elasticsearch.index.shard.IndexShard;
 import org.elasticsearch.index.shard.ShardId;
@@ -110,8 +111,8 @@ protected TermVectorsResponse shardOperation(TermVectorsRequest request, ShardId
     }
 
     @Override
-    protected TermVectorsResponse newResponse() {
-        return new TermVectorsResponse();
+    protected Writeable.Reader<TermVectorsResponse> getResponseReader() {
+        return TermVectorsResponse::new;
     }
 
     @Override
diff --git a/server/src/main/java/org/elasticsearch/index/seqno/RetentionLeaseActions.java b/server/src/main/java/org/elasticsearch/index/seqno/RetentionLeaseActions.java
index dfa985cc5a684..c69a4c6fab042 100644
--- a/server/src/main/java/org/elasticsearch/index/seqno/RetentionLeaseActions.java
+++ b/server/src/main/java/org/elasticsearch/index/seqno/RetentionLeaseActions.java
@@ -35,6 +35,7 @@
 import org.elasticsearch.common.inject.Inject;
 import org.elasticsearch.common.io.stream.StreamInput;
 import org.elasticsearch.common.io.stream.StreamOutput;
+import org.elasticsearch.common.io.stream.Writeable;
 import org.elasticsearch.common.lease.Releasable;
 import org.elasticsearch.index.IndexService;
 import org.elasticsearch.index.shard.IndexShard;
@@ -119,8 +120,8 @@ protected Response shardOperation(final T request, final ShardId shardId) {
         abstract void doRetentionLeaseAction(IndexShard indexShard, T request, ActionListener<Response> listener);
 
         @Override
-        protected Response newResponse() {
-            return new Response();
+        protected Writeable.Reader<Response> getResponseReader() {
+            return Response::new;
         }
 
         @Override
@@ -169,6 +170,10 @@ void doRetentionLeaseAction(final IndexShard indexShard, final AddRequest reques
                         ActionListener.map(listener, r -> new Response()));
             }
 
+            @Override
+            protected Writeable.Reader<Response> getResponseReader() {
+                return Response::new;
+            }
         }
 
         @Override
@@ -392,6 +397,12 @@ public RemoveRequest(final ShardId shardId, final String id) {
 
     public static class Response extends ActionResponse {
 
+        public Response() {
+        }
+
+        Response(StreamInput in) throws IOException {
+            super(in);
+        }
     }
 
 }
diff --git a/server/src/test/java/org/elasticsearch/action/admin/indices/mapping/get/GetFieldMappingsResponseTests.java b/server/src/test/java/org/elasticsearch/action/admin/indices/mapping/get/GetFieldMappingsResponseTests.java
index 2b8db458eb82f..472b4ddb4a3d1 100644
--- a/server/src/test/java/org/elasticsearch/action/admin/indices/mapping/get/GetFieldMappingsResponseTests.java
+++ b/server/src/test/java/org/elasticsearch/action/admin/indices/mapping/get/GetFieldMappingsResponseTests.java
@@ -23,11 +23,12 @@
 import org.elasticsearch.common.bytes.BytesArray;
 import org.elasticsearch.common.io.stream.BytesStreamOutput;
 import org.elasticsearch.common.io.stream.StreamInput;
+import org.elasticsearch.common.io.stream.Writeable;
 import org.elasticsearch.common.xcontent.LoggingDeprecationHandler;
 import org.elasticsearch.common.xcontent.ToXContent;
 import org.elasticsearch.common.xcontent.XContentParser;
 import org.elasticsearch.common.xcontent.XContentType;
-import org.elasticsearch.test.AbstractStreamableXContentTestCase;
+import org.elasticsearch.test.AbstractSerializingTestCase;
 
 import java.io.IOException;
 import java.util.Collections;
@@ -38,7 +39,7 @@
 import static org.elasticsearch.rest.BaseRestHandler.INCLUDE_TYPE_NAME_PARAMETER;
 import static org.hamcrest.CoreMatchers.equalTo;
 
-public class GetFieldMappingsResponseTests extends AbstractStreamableXContentTestCase<GetFieldMappingsResponse> {
+public class GetFieldMappingsResponseTests extends AbstractSerializingTestCase<GetFieldMappingsResponse> {
 
     public void testManualSerialization() throws IOException {
         Map<String, Map<String, Map<String, FieldMappingMetaData>>> mappings = new HashMap<>();
@@ -48,9 +49,8 @@ public void testManualSerialization() throws IOException {
 
         try (BytesStreamOutput out = new BytesStreamOutput()) {
             response.writeTo(out);
-            GetFieldMappingsResponse serialized = new GetFieldMappingsResponse();
             try (StreamInput in = StreamInput.wrap(out.bytes().toBytesRef().bytes)) {
-                serialized.readFrom(in);
+                GetFieldMappingsResponse serialized = new GetFieldMappingsResponse(in);
                 FieldMappingMetaData metaData = serialized.fieldMappings("index", "type", "field");
                 assertNotNull(metaData);
                 assertEquals(new BytesArray("{}"), metaData.getSource());
@@ -106,13 +106,13 @@ protected GetFieldMappingsResponse doParseInstance(XContentParser parser) throws
     }
 
     @Override
-    protected GetFieldMappingsResponse createBlankInstance() {
-        return new GetFieldMappingsResponse();
+    protected GetFieldMappingsResponse createTestInstance() {
+        return new GetFieldMappingsResponse(randomMapping());
     }
 
     @Override
-    protected GetFieldMappingsResponse createTestInstance() {
-        return new GetFieldMappingsResponse(randomMapping());
+    protected Writeable.Reader<GetFieldMappingsResponse> instanceReader() {
+        return GetFieldMappingsResponse::new;
     }
 
     @Override
diff --git a/server/src/test/java/org/elasticsearch/action/explain/ExplainResponseTests.java b/server/src/test/java/org/elasticsearch/action/explain/ExplainResponseTests.java
index 2a04a97667722..9f1ee08844b66 100644
--- a/server/src/test/java/org/elasticsearch/action/explain/ExplainResponseTests.java
+++ b/server/src/test/java/org/elasticsearch/action/explain/ExplainResponseTests.java
@@ -23,13 +23,14 @@
 import org.elasticsearch.common.bytes.BytesArray;
 import org.elasticsearch.common.bytes.BytesReference;
 import org.elasticsearch.common.document.DocumentField;
+import org.elasticsearch.common.io.stream.Writeable;
 import org.elasticsearch.common.xcontent.ToXContent;
 import org.elasticsearch.common.xcontent.XContentBuilder;
 import org.elasticsearch.common.xcontent.XContentFactory;
 import org.elasticsearch.common.xcontent.XContentParser;
 import org.elasticsearch.common.xcontent.XContentType;
 import org.elasticsearch.index.get.GetResult;
-import org.elasticsearch.test.AbstractStreamableXContentTestCase;
+import org.elasticsearch.test.AbstractSerializingTestCase;
 import org.elasticsearch.test.RandomObjects;
 
 import java.io.IOException;
@@ -42,15 +43,16 @@
 import static java.util.Collections.singletonMap;
 import static org.hamcrest.Matchers.equalTo;
 
-public class ExplainResponseTests extends AbstractStreamableXContentTestCase<ExplainResponse> {
+public class ExplainResponseTests extends AbstractSerializingTestCase<ExplainResponse> {
+
     @Override
     protected ExplainResponse doParseInstance(XContentParser parser) throws IOException {
         return ExplainResponse.fromXContent(parser, randomBoolean());
     }
 
     @Override
-    protected ExplainResponse createBlankInstance() {
-        return new ExplainResponse();
+    protected Writeable.Reader<ExplainResponse> instanceReader() {
+        return ExplainResponse::new;
     }
 
     @Override
diff --git a/server/src/test/java/org/elasticsearch/action/termvectors/TermVectorsUnitTests.java b/server/src/test/java/org/elasticsearch/action/termvectors/TermVectorsUnitTests.java
index 0cd9d3130f176..8ab452950a87a 100644
--- a/server/src/test/java/org/elasticsearch/action/termvectors/TermVectorsUnitTests.java
+++ b/server/src/test/java/org/elasticsearch/action/termvectors/TermVectorsUnitTests.java
@@ -77,8 +77,7 @@ public void testStreamResponse() throws Exception {
         // read
         ByteArrayInputStream esInBuffer = new ByteArrayInputStream(outBuffer.toByteArray());
         InputStreamStreamInput esBuffer = new InputStreamStreamInput(esInBuffer);
-        TermVectorsResponse inResponse = new TermVectorsResponse("a", "b", "c");
-        inResponse.readFrom(esBuffer);
+        TermVectorsResponse inResponse = new TermVectorsResponse(esBuffer);
 
         // see if correct
         checkIfStandardTermVector(inResponse);
@@ -93,8 +92,7 @@ public void testStreamResponse() throws Exception {
         // read
         esInBuffer = new ByteArrayInputStream(outBuffer.toByteArray());
         esBuffer = new InputStreamStreamInput(esInBuffer);
-        inResponse = new TermVectorsResponse("a", "b", "c");
-        inResponse.readFrom(esBuffer);
+        inResponse = new TermVectorsResponse(esBuffer);
         assertTrue(inResponse.isExists());
 
     }
diff --git a/x-pack/plugin/ccr/src/main/java/org/elasticsearch/xpack/ccr/action/ShardChangesAction.java b/x-pack/plugin/ccr/src/main/java/org/elasticsearch/xpack/ccr/action/ShardChangesAction.java
index 0ef14115eab32..33b8a274431d2 100644
--- a/x-pack/plugin/ccr/src/main/java/org/elasticsearch/xpack/ccr/action/ShardChangesAction.java
+++ b/x-pack/plugin/ccr/src/main/java/org/elasticsearch/xpack/ccr/action/ShardChangesAction.java
@@ -22,6 +22,7 @@
 import org.elasticsearch.common.inject.Inject;
 import org.elasticsearch.common.io.stream.StreamInput;
 import org.elasticsearch.common.io.stream.StreamOutput;
+import org.elasticsearch.common.io.stream.Writeable;
 import org.elasticsearch.common.unit.ByteSizeValue;
 import org.elasticsearch.common.unit.TimeValue;
 import org.elasticsearch.index.IndexNotFoundException;
@@ -61,7 +62,12 @@ private ShardChangesAction() {
 
     @Override
     public Response newResponse() {
-        return new Response();
+        throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
+    }
+
+    @Override
+    public Writeable.Reader<Response> getResponseReader() {
+        return Response::new;
     }
 
     public static class Request extends SingleShardRequest<Request> {
@@ -246,6 +252,17 @@ public long getTookInMillis() {
         Response() {
         }
 
+        Response(StreamInput in) throws IOException {
+            super(in);
+            mappingVersion = in.readVLong();
+            settingsVersion = in.readVLong();
+            globalCheckpoint = in.readZLong();
+            maxSeqNo = in.readZLong();
+            maxSeqNoOfUpdatesOrDeletes = in.readZLong();
+            operations = in.readArray(Translog.Operation::readOperation, Translog.Operation[]::new);
+            tookInMillis = in.readVLong();
+        }
+
         Response(
             final long mappingVersion,
             final long settingsVersion,
@@ -265,15 +282,8 @@ public long getTookInMillis() {
         }
 
         @Override
-        public void readFrom(final StreamInput in) throws IOException {
-            super.readFrom(in);
-            mappingVersion = in.readVLong();
-            settingsVersion = in.readVLong();
-            globalCheckpoint = in.readZLong();
-            maxSeqNo = in.readZLong();
-            maxSeqNoOfUpdatesOrDeletes = in.readZLong();
-            operations = in.readArray(Translog.Operation::readOperation, Translog.Operation[]::new);
-            tookInMillis = in.readVLong();
+        public void readFrom(final StreamInput in) {
+            throw new UnsupportedOperationException("usage of Streamable is to be replaced by Writeable");
         }
 
         @Override
@@ -459,8 +469,8 @@ protected ShardsIterator shards(ClusterState state, InternalRequest request) {
         }
 
         @Override
-        protected Response newResponse() {
-            return new Response();
+        protected Writeable.Reader<Response> getResponseReader() {
+            return Response::new;
         }
 
     }
diff --git a/x-pack/plugin/ccr/src/main/java/org/elasticsearch/xpack/ccr/action/repositories/PutCcrRestoreSessionAction.java b/x-pack/plugin/ccr/src/main/java/org/elasticsearch/xpack/ccr/action/repositories/PutCcrRestoreSessionAction.java
index 393548225a0c2..91ec057ac4eb6 100644
--- a/x-pack/plugin/ccr/src/main/java/org/elasticsearch/xpack/ccr/action/repositories/PutCcrRestoreSessionAction.java
+++ b/x-pack/plugin/ccr/src/main/java/org/elasticsearch/xpack/ccr/action/repositories/PutCcrRestoreSessionAction.java
@@ -77,8 +77,8 @@ protected PutCcrRestoreSessionResponse shardOperation(PutCcrRestoreSessionReques
         }
 
         @Override
-        protected PutCcrRestoreSessionResponse newResponse() {
-            return new PutCcrRestoreSessionResponse();
+        protected Writeable.Reader<PutCcrRestoreSessionResponse> getResponseReader() {
+            return PutCcrRestoreSessionResponse::new;
         }
 
         @Override
diff --git a/x-pack/plugin/ccr/src/test/java/org/elasticsearch/xpack/ccr/action/ShardChangesResponseTests.java b/x-pack/plugin/ccr/src/test/java/org/elasticsearch/xpack/ccr/action/ShardChangesResponseTests.java
index 0e48fc8e57ca3..a5b28caf9dfb2 100644
--- a/x-pack/plugin/ccr/src/test/java/org/elasticsearch/xpack/ccr/action/ShardChangesResponseTests.java
+++ b/x-pack/plugin/ccr/src/test/java/org/elasticsearch/xpack/ccr/action/ShardChangesResponseTests.java
@@ -5,10 +5,11 @@
  */
 package org.elasticsearch.xpack.ccr.action;
 
+import org.elasticsearch.common.io.stream.Writeable;
 import org.elasticsearch.index.translog.Translog;
-import org.elasticsearch.test.AbstractStreamableTestCase;
+import org.elasticsearch.test.AbstractWireSerializingTestCase;
 
-public class ShardChangesResponseTests extends AbstractStreamableTestCase<ShardChangesAction.Response> {
+public class ShardChangesResponseTests extends AbstractWireSerializingTestCase<ShardChangesAction.Response> {
 
     @Override
     protected ShardChangesAction.Response createTestInstance() {
@@ -34,8 +35,7 @@
     }
 
     @Override
-    protected ShardChangesAction.Response createBlankInstance() {
-        return new ShardChangesAction.Response();
+    protected Writeable.Reader<ShardChangesAction.Response> instanceReader() {
+        return ShardChangesAction.Response::new;
     }
-
 }
